function [Pvalueadj] = Holm_adj_P(Pvalue)
% This function is used to calculate the step-down Holm's adjusted P-values
% Input: Pvalue is a P x 1 vector 
% Pvalue = [0.99, 0.1, 0.7]'  
P = size(Pvalue,1); 
[Ps, Idx] = sort(Pvalue); 
scaled = P-(1:P)+1; 
Pvalueadj = Pvalue; 

for i = 1: P
    Pvalueadj(Idx(i)) = Pvalue(Idx(i))*scaled(i); 
end 
Pvalueadj = min(Pvalueadj,1); 

 
 