clear;
clc

[gdp_num,txt1] = xlsread('./okun/State_RealGDP.xlsx');
[unemp_num,txt2] = xlsread('./okun/US_unemployment.xlsx');
[wage_num,txt3] = xlsread('./okun/US_wage.xlsx');

[ngdp,N] = size(gdp_num);
rgdp = log(gdp_num(5:ngdp,:)./gdp_num(1:ngdp-4,:))*100;
ngdp = ngdp - 4;
nunemp = size(unemp_num,1);
nq = fix(nunemp/3);
nwage = size(wage_num,1);
nqw = fix(nwage/3);

M_quarter_ave = zeros(nq,nunemp);
M_quarter_last = zeros(nq,nunemp);
for i=1:nq
    M_quarter_ave(i,(i-1)*3+1:i*3) = ones(1,3)/3;
    M_quarter_last(i,(i-1)*3+1:i*3) = [0 0 1];
end
unemp1 = M_quarter_ave*unemp_num;
unemp2 = M_quarter_last*unemp_num;

Mw_quarter_ave = zeros(nqw,nwage);
Mw_quarter_last = zeros(nqw,nwage);
for i=1:nqw
    Mw_quarter_ave(i,(i-1)*3+1:i*3) = ones(1,3)/3;
    Mw_quarter_last(i,(i-1)*3+1:i*3) = [0 0 1];
end
wage1 = Mw_quarter_ave*wage_num;
wage2 = Mw_quarter_last*wage_num;

wage1 = wage1(1:size(wage1,1)-1,:); % delete the last obs, so that all data ends at 2022Q1.
wage2 = wage2(1:size(wage2,1)-1,:);

nqw = size(wage1,1);

rwage = log(wage1(5:nqw,:)./wage1(1:nqw-4,:))*100;
nqw = size(rwage,1);

T1 = 0;
T = min(ngdp,nqw)-T1;

X1 = unemp1(nq-T1-T+1:nq-T1,2:end);
X2 = rgdp(ngdp-T1-T+1:ngdp-T1,2:end);
Y = rwage(nqw-T1-T+1:nqw-T1,2:end);

%y = reshape(Y-kron(mean(Y,1),ones(T,1)),N*T,1);
%x1 = reshape(X1-kron(mean(X1,1),ones(T,1)),N*T,1);
%x2 = reshape(X2-kron(mean(X2,1),ones(T,1)),N*T,1);
[T,N] = size(Y); 
y = reshape(Y,N*T,1);
x1 = reshape(X1,N*T,1);
x2 = reshape(X2,N*T,1);

y = y - mean(y);
x1 = x1 - mean(x1);
x2 = x2 - mean(x2);

x = [x1];
p = size(x,2);
%rr=panelfe(y,x,T,1);
%disp(rr.R2)
%disp(rr.b(1:2))
%return;

%R = 1;
  %  h=2.35/sqrt(12)*T^(-1/5)*N^(-1/10);
 ho  = 3 * 2.35/sqrt(12)*T^(-2/9)*N^(-2/9);

[res, ~,Sigma] =  kpanelife(y,x,T,2,ho ); 
  R = res.R;
  beta11 = res.beta; 
 eps = reshape(res.e,T,N);  
 sige = mean(eps.^2,'all')

 hopt = sige^(1/2) * 2.35/sqrt(12)*T^(-2/9)*N^(-2/9); 
[res, ~,Sigma] =  kpanelife(y,x,T,2,hopt ); 
beta12 = res.beta; 

% R = 2
disp(['Number of factors: ' num2str(R)]);
varc=Sigma; 

[est2,C2,~,~,~,err,Sigma] = panelife(y,x,T,R);
beta2 = repmat(est2',T,1);

[est3,C3] = tvpanelife(y,x,T,R,[],(1:T+1)');
beta3 = reshape(est3,p,T)';

[est4] = Average_local(Y, X1,  hopt, 2);


year = (2008:2021)';
month = (3:3:12)';
yr = [kron(year,ones(4,1));2022];
qr = [repmat(month,length(year),1);3];
mt = ones(length(year)*4+1,1);
date = datenum([yr qr mt]);
figure(1)
%plot([res.beta beta2 beta3]);
CIlow = res.beta-1.96*sqrt(varc); 
CIhigh = res.beta+1.96*sqrt(varc);
plot(date,res.beta,'-','LineWidth',2,'Color',1/255*[43 140 190]),hold;
plot(date,CIlow,'.','LineWidth',2,'Color',1/255*[43 140 190]); 
plot(date,CIhigh,'.','LineWidth',2,'Color',1/255*[43 140 190]);
plot(date,beta2,'--','LineWidth',2,'Color',1/255*[222 45 38]);
  plot(date,beta3,':','LineWidth',2,'Color',1/255*[254 196 79]);
 % plot(date,beta3,':','LineWidth',2,'Color',1/255*[254 196 79]);   
 hold off;
box off;
legend('LLS','LS1','LS2'); legend boxoff;
datetick('x','yyyy','keepticks')
xlabel('Year');
ylabel('\beta_t');
%title('Slope Estimates of the Phillips Curve');
axis tight;
%recessionplot;
% 
kernelType=1; XTol=1e-3; maxIter=1000;
nb = 500;

 randn('seed',2025);  
 rand('seed',2025);   
% 0.0400    0.0040    0.0420

h=2.5* 2.35/sqrt(12)*T^(-1/4)*N^(-1/4);

[p1,p2,p3 ] = boot_test_fixed_regressor(y,x,T,R,h ,kernelType,XTol,maxIter,nb);
disp([p1 p2 p3]);
 


