   function [ covprob ]=mc_CI_boot2(N,T,mtype,etype,sigma,M)
%% This function is used to show the average coverage probability 
%% and average lengths of confidence intervals 
 
p =2; 
kernelType = 1; 
 
covprob = zeros(1,4); 
CI_length = zeros(1,2);
R = 2;
 
 %% generate data
 [Y,X,beta0,C0]=dgp(N,T,mtype,etype,sigma);
 h= 2.35/sqrt(12)*T^(-2/9)*N^(-2/9);
 Th = ceil(T*h); 
 %% estimate the time-varying panel with time-varying IFE
 [res1,~, sig, beta_bc, D, Omega] = kpanelife(Y,X,T,R,h);

 beta1 = res1.beta;
 C1 = res1.C;
 beta2 = beta_bc;
 e = res1.e; 
 sig1 = [sqrt(sig(:,1)), sqrt(sig(:,4))];
 betalow1 = beta1-1.96*sig1;
 betalow2 = beta2-1.96*sig1;
 betaup1 = beta1+1.96*sig1;
 betaup2 = beta2+1.96*sig1;
 X1 = reshape(X(:,1), T, N);
 X2 = reshape(X(:,2), T, N);
 CC = reshape(C1, T, N); 
 YY = reshape(Y, T, N);
 TrM1 = zeros(M,T); 
 TrM2 = zeros(M,T); 

   parfor i=1:M
      % i
     ee = reshape(e.*randn(N*T,1), T,N);
     YY1 = X1.*(beta1(:,1)*ones(1,N)) + X2.*(beta1(:,2)*ones(1,N)) + CC + ee; 
     Y1 = reshape(YY1, N*T,1); 
     [resb,~, sigb,]= kpanelife(Y1,X,T,R,h);
     betab = resb.beta;  % dim: T x 2
     sig1b = [sqrt(sigb(:,1)), sqrt(sigb(:,4))];  % dim T x 2
     t_stb = (resb.beta -res1.beta)./sig1b; 
     TrM1(i,:) =  t_stb(:,1)'; 
     TrM2(i,:) = t_stb(:,2)';  
  end
   Cv1 = quantile(TrM1,0.975)'; 
   Cv2 = quantile(TrM2,0.975)'; 

    beta = beta1; 
    betaUCIlow1 = beta(:,1) - Cv1.*sqrt(sig(:,1)); 
    betaUCIlow2= beta(:,2)- Cv2.*sqrt(sig(:,4)); 

    betaUCIup1 = beta(:,1) + Cv1.*sqrt(sig(:,1)); 
    betaUCIup2= beta(:,2) + Cv2.*sqrt(sig(:,4)); 
  
    
    covprob1 = mean((beta0>betalow1).*(beta0<betaup1),'all');
    covprob2 = mean((beta0>betalow2).*(beta0<betaup2),'all');
    covprobUCI1 = mean((beta0(:,1)>betaUCIlow1  ).*(beta0(:,1)<betaUCIup1  ),'all');
    covprobUCI2 = mean((beta0(:,2)>betaUCIlow2 ).*(beta0(:,2)<betaUCIup2  ),'all');
    covprobUCI = mean([covprobUCI1, covprobUCI2]);
    covprobLLS = mean([covprob1, covprob2]); 
    covprob  = [covprobLLS, covprobUCI];    
 