function [F,L,C,V] = o3(Y,T,R)
% estimate pure factor structure.

n = length(Y);
N = n/T;


e = reshape(Y,T,N);
Q = e*e'/n;

[W,lam] = eig(Q);
F = W(:,T:-1:T-R+1)*sqrt(T);
V = lam(T:-1:T-R+1,T:-1:T-R+1);

L = (F'*e/T)'; % N by R
C = reshape(F*L',N*T,1);

