function est = oracle1(Y,X,Z,regime,L)
[N,r] = size(L);
[n,p] = size(X);
q = size(Z,2);
T = n/N;
m = length(regime)-2;

M = eye(N)-L*pinv(L'*L)*L';
Phi = zeros((m+1)*p+q,(m+1)*p+q);
phi = zeros((m+1)*p+q,1);

for j=1:m+1
    G = zeros(p,p);
    g = zeros(p,1);
    for t=regime(j):regime(j+1)-1
        G = G + X(t:T:n,:)'*M*X(t:T:n,:);
        g = g + X(t:T:n,:)'*M*Y(t:T:n);
    end
    Phi((j-1)*p+1:j*p,(j-1)*p+1:j*p) = G;
    phi((j-1)*p+1:j*p) = g;
end

if q>0

    for j=1:m+1
        G = zeros(q,p);
        for t=regime(j):regime(j+1)-1
            G = G + Z(t:T:n,:)'*M*X(t:T:n,:);
        end
        Phi((j-1)*p+1:j*p,(m+1)*p+1:(m+1)*p+q) = G';
        Phi((m+1)*p+1:(m+1)*p+q,(j-1)*p+1:j*p) = G;
    end
    
    G = zeros(q,q);
    g = zeros(q,1);
    for t=1:T
        G = G + Z(t:T:n,:)'*M*Z(t:T:n,:);
        g = g + Z(t:T:n,:)'*M*Y(t:T:n);
    end
    Phi((m+1)*p+1:(m+1)*p+q,(m+1)*p+1:(m+1)*p+q) = G;
    phi((m+1)*p+1:(m+1)*p+q) = g;
end
est = Phi\phi;



