function [L,V] = oracle2(Y,X,Z,regime,est,r)

[n,p] = size(X);
q = size(Z,2);
m = length(regime)-2;

T = regime(m+2)-1;
N = n/T;
alpha = reshape(est(1:(m+1)*p),p,m+1)';
eta = est(p*(m+1)+1:p*(m+1)+q);

beta = alpha2beta(alpha,regime);

Q = zeros(N,N);

if q>0
    for t = 1:T
        et = Y(t:T:n) - X(t:T:n,:)*(beta(t,:)') - Z(t:T:n,:)*eta;
        Q = Q + et*et';
    end
else
    for t = 1:T
        et = Y(t:T:n) - X(t:T:n,:)*(beta(t,:)');
        Q = Q + et*et';
    end
end    
Q = Q/n;

[W,lam] = eig(Q);
L = W(:,N:-1:N-r+1)*sqrt(N);
V = lam(N:-1:N-r+1,N:-1:N-r+1);

