  function J2 = test2(X,beta,e,L,F,h,kernelType)
 


[n,p] = size(X);
[T,R] = size(F);
N = n/T;

%% calculate the test statistic 

M2 = norm(beta - repmat(mean(beta,1),T,1))^2/T;

%% Calculate the bias term 

Dinv2 = zeros(T,p*p);
a = zeros(T,N*N);
chi = zeros(T,N*T*p);
chiTTNP = zeros(T, T, N, p); 
f = F*F'; % T by T
X_bar = zeros(N,p);
for i=1:p
    X_bar(:,i) = mean(reshape(X(:,i),T,N))';
end
 
for t=1:T
    %% calculate Dt 
    w = khtr(h,(1:T)',t,T,kernelType).^(1/2); % T by 1
    F_ = repmat(w,1,R).*F; % T by R
    L_ = L(t:T:n,:); % N by R
    Z = zeros(N*T,p);
    Pf_ = F_*((F_'*F_)\F_');
    Mf_ = eye(T)-Pf_; % T by T
    Ml = eye(N)-L_*((L_'*L_)\L_');% N by N
    X_ = X.*repmat(w,N,p);
    for i=1:p
        Xp = reshape(X_(:,i),T,N);
        Z(:,i) = reshape(Mf_*Xp*Ml,n,1);    
    end
    D = Z'*Z/(n);
    Dinv = D\eye(p); % p by p
    Dinv2(t,:) = reshape(Dinv*Dinv,1,p*p);
  
    %% calculate a
    lt = L(t:T:n,:); % N by R
    LL = lt'*lt/N; % R by R
    a1 = lt*(LL\lt'); % N by N;
    a(t,:)=reshape(a1,1,N*N);
    %% calculate chi_is^t 
    % at = reshape(a(t,:),N,N);
    X1 = kron((X_bar'*a1/N)',ones(T,1)); % NT by p;
    w = khtr(h,(1:T)',t,T,kernelType);% T by 1
    X2 = kron(X_bar,f*w/T); % NT by p
    X3 = kron(a1*X_bar,f*w/n); % NT by p
    chi(t,:) = reshape(X-X1-X2+X3,1,n*p);
    chitemp = reshape(X-X1-X2+X3, T, N, p); 
    chiTTNP(t,:,:,:) = chitemp; 
end

%% calculate vsig without many loop, have checked, correct 
% vsig = zeros(T*T,N*N);
% for s=1:T
%     for r=1:T
%         tmp = zeros(N,N);
%         for t=1:T % supposed to be 1:T
%             w = khtr_b(h,(1:T)',t,T,kernelType);% T by 1
% %            Xt = reshape(chi(t,:),n,p);
% %            Xts = Xt(s:T:n,:).*w(s); % N by p
% %            Xtr = Xt(r:T:n,:).*w(r); % N by p
%             Xts = reshape(chi(t,s:T:n*p),N,p).*w(s);   % N x p 
%             Xtr = reshape(chi(t,r:T:n*p),N,p).*w(r);   % N x p 
%             tmp=tmp+Xts*reshape(Dinv2(t,:),p,p)*Xtr'; % N by N
%         end
%         vsig((s-1)*T+r,:)=reshape(tmp/T,1,N*N);
%     end
% end

%% another method to calculate vsig 
vsig2 = zeros(T,T, N, N); 
%% recall that Dinv2: T x P^2 
Dinv2TPP = reshape (Dinv2,T, p, p); 
Dinv2PPT = permute(Dinv2TPP, [2,3,1]);   % (k1, k2, t)
%% recall that chiTTNP: T x T x N x p (t,s,i, k)
for t = 1:T 
   w = khtr_b(h,(1:T)',t,T,kernelType);  % T by 1
   chi_t = permute(squeeze(chiTTNP(t, :,:,:)), [2,3,1]);  %  N x p x T 
   w_11T = permute(w,[2,3,1]);        % 1 x 1 x T
   Xts = permute(pagemtimes(chi_t,w_11T), [3,1,2]);     % T x N x p   
   Dinv_t = Dinv2PPT(:,:,t);          % P x P 
   
   AA_NP1T = reshape(permute(Xts, [2,3,1]), [N*p, 1, T]) ; 
   AA_NPTT = repmat(AA_NP1T,[1, T, 1] );     % NP x T x T 
   AA_NPT = reshape(permute(Xts, [2,3,1]), [N*p, T]) ;  % NP x T 
   AA_NPTT2 = repmat(AA_NP1T,[1, 1, T] );
   A1 = reshape(AA_NPTT, [N, p, T^2 ]); 
   A2 = reshape(AA_NPTT2, [N, p, T^2]); 
   BB_TT = repmat(Dinv_t, [1,1,T^2]); 
   AB = pagemtimes(A1, BB_TT);          % dim: N x P x T^2 
   ABA = pagemtimes(AB, pagetranspose(A2));   % dim: N x P x T^2
   vsig2 = vsig2 + T^(-1)* permute(reshape(ABA, [N, N, T, T]), [4,3,2,1]) ;  % dim: T x T x N x N 
   
end 
vsig  = reshape(vsig2, [T*T,N*N] ); 
 

B2a = 0;
for i=1:N
    Vs = reshape(vsig(:,(i-1)*N+i),T,T); 
    B2a = B2a + e((i-1)*T+1:i*T)'*Vs*e((i-1)*T+1:i*T);
end
B2a = B2a*sqrt(h)/n;
B2b = 0;
for t=1:T % supposed to be 1:T
    w = khtr_b(h,(1:T)',t,T,kernelType);% T by 1
    Xt = reshape(chi(t,:),n,p);
    for i=1:N
        exi = repmat(w,1,p).*repmat(e((i-1)*T+1:i*T),1,p).*Xt((i-1)*T+1:i*T,:); % T by p
        for j=1:(i-1)
            exj = repmat(w,1,p).*repmat(e((j-1)*T+1:j*T),1,p).*Xt((j-1)*T+1:j*T,:); % T by p
            B2b = B2b+trace(exi * reshape(Dinv2(t,:),p,p) * exj');
        end
    end
end
B2b = B2b*2*sqrt(h)/(N*T^2);
V2 = 0;
for i=1:N
    for j=1:N
        if i~=j
            Vsr = reshape(vsig(:,(i-1)*N+j),T,T);
            ei = e((i-1)*T+1:i*T);
            ej = e((j-1)*T+1:j*T);
            V2 = V2 + (ei'*Vsr*ej)^2;
        end
    end
end
V2 = V2*2*h/n^2;
J2 = V2^(-1/2)*(n*sqrt(h)*M2-B2a-B2b);
 