function [Pvalueadj] = Holm_adj_P(Pvalue)
% This function is used to calculate the step-down Holm's adjusted P-values
% Input: Pvalue is a P x 1 vector 
% Pvalue = [0.99, 0.1, 0.7]'  
P = size(Pvalue,1); 
[Ps, Idx] = sort(Pvalue); 
scaled = P-(1:P)+1; 
Pvalueadj = Pvalue; 

for i = 1: P
    Pvalueadj(Idx(i)) = Pvalue(Idx(i))*scaled(i); 
end 
Pvalueadj = min(Pvalueadj,1); 


   % 
   % 
   % 
   % 
   % 
   %  % 找到向量中的元素及其索引，并按值排序
   %  vec = Pvalue
   %  [sorted_vec, sorted_idx] = sort(Pvalue);
   % 
   %  % 初始化扩大倍数
   %  scale_factors = P - (1:length(vec))+1;
   %  scale_factors(scale_factors < 1) = 1;  % 所有负值的倍数设置为1
   % 
   %  % 根据排序后的索引对向量进行扩大
   %  scaled_vector = vec;
   %  for i = 1:length(vec)
   %      scaled_vector(sorted_idx(i)) = vec(sorted_idx(i)) * scale_factors(i);
   %  end
   % vec 
   % scaled_vector
   % fS = min(scaled_vector,1)
 