function y = ar1rnd(a,sigma,T,N)
% generate AR(1) processes in columns
% y(t) = a * y(t-1) + e(t),
%   where abs(a)<1 and e(t)~N(0,sigma^2)
if nargin < 4
    N=1;
end
T0 = 100;
y = zeros(T+T0,N);
y(1,:) = randn(1,N)./sqrt(1-a.^2).*sigma;
e = (ones(T+T0,1)*sigma).*randn(T+T0,N);
for t=2:T+T0
    y(t,:) = a.*y(t-1,:)+e(t,:);
end
y = y(T0+1:T+T0,:);




