function [beta_bc,B,Sigma,D,Omega, B1,B2,B3] = biasterm(t,res1,X,T,R,h,kernelType)
[n,p]=size(X);
N = n/T;

beta = res1.beta;
e = res1.e;
F = res1.F;
L = res1.L;

w = khtr(h,(1:T)',t,T,kernelType).^(1/2); % T by 1
F_ = repmat(w,1,R).*F; % T by R
L_ = L(t:T:n,:); % N by R
Z = zeros(N*T,p);
if cond(F_'*F_)<1e8
    Pf_ = F_*((F_'*F_)\F_');
else
    Pf_ = F_*((1e-8*eye(R)+F_'*F_)\F_');
end
Mf_ = eye(T)-Pf_; % T by T
if cond(L_'*L_)<1e8
    Ml = eye(N)-L_*((L_'*L_)\L_');% N by N
else
    Ml = eye(N)-L_*((1e-8*eye(R)+L_'*L_)\L_');% N by N
end
X_ = X.*repmat(w,N,p);
for i=1:p
    Xp = reshape(X_(:,i),T,N);
    Z(:,i) = reshape(Mf_*Xp*Ml,n,1);    
end
D = Z'*Z/(n*h);

e_ = e.*repmat(w,N,1);
Ze = Z.*repmat(e_,1,p);
Omega = Ze'*Ze/(n*h);

B1 = zeros(p,1);
B2 = zeros(p,1);
B3 = zeros(p,1);
M = T^(1/5);
for r=1:T-1
    for s=r+1:T
        tau=(s-r)/M;
        B1 = B1 + (tau>=0)&(tau<=1)*Pf_(r,s)*sum(repmat(e_(r:T:n),1,p).*X(s:T:n,:))';
    end
end

B1 = -B1*h/N;
LLm = (L_'*L_/N);
if cond(LLm)<1e8
    LL = LLm\L_'; % R by N
else
    LL = (LLm+1e-8*eye(R))\L_'; % N by N;
end    
at = L_*LL;
XM = zeros(n,p);
for pp=1:p
    XM(:,pp)=reshape(reshape(X_(:,pp),T,N)*at/N,n,1);
end

e_ = reshape(e_,T,N); % T by N
ee = e_'*e_/T; % N by N
%for i=1:N
%    XMi = XM((i-1)*T+1:i*T,:); % T by p
%    Xi = X((i-1)*T+1:i*T,:);
%    for j=1:N
%        B2 = B2 + (Xi-XMi)'* F_ * LL(:,j) * ee(i,j);
%    end
%end
for i=1:N
    XMi = XM((i-1)*T+1:i*T,:); % T by p
    Xi = X((i-1)*T+1:i*T,:);
    B2 = B2 + (Xi-XMi)'* F_ * LL * ee * ones(N,1);
end

B2 = -1/n*B2;

for i=1:N
    Xi = X_((i-1)*T+1:i*T,:);
    B3 = B3 + Xi' * Mf_ * (e_*e_') * F_ * LL(:,i);
end
B3 = -h/(N*n)*B3;

if cond(D)<1e8
    Dinv = D\eye(p);
else
    Dinv = (D+1e-8*eye(p))\eye(p);
end
B = Dinv*(B1/(T*h) + B2/N + B3/(T*h));

beta_bc = beta(t,:)' - B;
Sigma = Dinv*Omega*Dinv'/(n*h);


