%% paper: On time-varying panel data models with time-varying interactive fixed effect 
%% This function is used to implement the simulation studies reported in Table 1: 
%% Finite sample performance of the slope coefficients 


clear all 
clc 

Nvec = [ 40, 80,120 ]; 
Tvec=[  40, 80, 120]; 
DGPvec=[1,2,3,4,5,6] ; 
Errorvec = [1,2,3]; 

SDGP = size(DGPvec,2);
SN = size(Nvec,2);
ST = size(Tvec,2); 
SE = size(Errorvec, 2); 

To = SN*ST*SDGP*SE; 
 BMSE= zeros(To,7);
 
 Mc = 500  ; 
 sigma = 1; 
 
  iTo = 0;    
  for eTY = 1: SE
      for iDGP = 1:SDGP
          for iN = 1:SN
              for iT = 1:ST
                   sd= ceil(rand(Mc,1)*10^6);
                  iTo = iTo+1
                  N = Nvec(iN);
                  T = Tvec(iT);
                  mtype=DGPvec(iDGP);
                  etype = Errorvec(eTY);
                  
                  [mneb,~,~,~] = mc(N,T,mtype,etype,sigma,Mc);
                  BMSE( iTo,:) = [etype, mtype , N,T, mneb];
                   csvwrite('BMSE.csv', BMSE);
              end
          end
      end
  end
