%% paper: On time-varying panel data models with time-varying interactive fixed effect 
%% This code is used to calculate the Empirical Rejection Rates and Holm’s (1979) Adjusted Empirical Rejection Rates
 

clear all 
clc 

Nvec = [40,80]; 
Tvec=[40, 80]; 
DGPvec=[1,2,3,4,5,6 ] ; 
Errorvec = [1]; 

SDGP = size(DGPvec,2);
SN = size(Nvec,2);
ST = size(Tvec,2); 
SE = size(Errorvec, 2); 

To = SN*ST*SDGP*SE; 
 Pvalue= zeros(To,22);
 
 Mc = 500 ; 
 nb = 200;

 sigma = 1; 
 
  iTo = 0;    
  for eTY = 1: SE
      for iDGP = 1:SDGP
          for iN = 1:SN
              for iT = 1:ST
                 sd= ceil(rand(Mc,1)*10^6);
                  iTo = iTo+1
                  N = Nvec(iN);
                  T = Tvec(iT);
                  mtype=DGPvec(iDGP);
                  etype = Errorvec(eTY);
                  Pr11 = mcboot_Holm(N,T,mtype,etype,sigma,Mc,nb);
                 %  [mneb,~,~,~] = mc(N,T,mtype,etype,sigma,Mc);
                  Pvalue( iTo,:) = [etype, mtype , N,T, Pr11];
                  writematrix(Pvalue, 'Pvalueadj.csv');
              end
          end
      end
  end
