  function [mcovprob,mCI_length,covprob,CI_length]=mc_CI(N,T,mtype,etype,sigma,M)
%% This function is used to show the average coverage probability 
%% and average lengths of confidence intervals 


covprob = zeros(M,3);
CI_length = zeros(M,2);
R = 2;

parfor i=1:M
    %% generate data 
    % N= 80; 
    % T = 120; 
    % mtype = 6; 
    % etype = 1;
    % sigma =1; 
    % R= 2; 

    [Y,X,beta0,C0]=dgp(N,T,mtype,etype,sigma);
    h=2.35/sqrt(12)*T^(-1/5)*N^(-1/10);
    %% estimate the time-varying panel with time-varying IFE 
    [res1,~, sig, beta_bc] = kpanelife(Y,X,T,R,h);
    beta1 = res1.beta;
    C1 = res1.C;
    beta2 = beta_bc; 
    sig1 = [sqrt(sig(:,1)), sqrt(sig(:,4))]; 
    sig1m = ones(T,1)*mean(sig1,1); 
    betalow1 = beta1-1.96*sig1; 
    betalow2 = beta1-1.96*sig1m; 
    betaup1 = beta1+1.96*sig1; 
    betaup2 = beta1+1.96*sig1m; 
    % plot(beta0)
    % hold
    % plot(betalow1)
    % plot(betalow2); 
    % plot(betaup1)
    % plot(betaup2)

   %  [est,C3] = tvpanelife(Y,X,T,R,[],(1:T+1)'); % ns-tv
   %  beta3 = reshape(est,2,T)';
    [est,C2,~,~,~,~,Sigma,~] = panelife(Y,X,T,R);
    beta3 = repmat(est',T,1);
    sig2 =ones(T,1)* [sqrt(Sigma(1,1)), sqrt(Sigma(2,2))];
    
    betalow3 = beta3- 1.96*sig2; 
    betaup3 = beta3+1.96*sig2; 
    
    covprob1 = mean((beta0>betalow1).*(beta0<betaup1),'all');
    covprob2 = mean((beta0>betalow2).*(beta0<betaup2),'all');
    covprob3 = mean((beta0>betalow3).*(beta0<betaup3),'all');
    covprob(i, :) = [covprob1, covprob2, covprob3]; 

    CI_length1 = mean((T*N*h)^(-1/2)*1.96*sig1*2, 'all');
    CI_length2 = mean((T*N)^(-1/2)*1.96*sig2*2, 'all');

    CI_length(i,:)=[CI_length1, CI_length2]; 

   % neb(i,:) = [norm(beta1-beta0) norm(beta2-beta0) norm(beta3-beta0)]/sqrt(2*T);
   %  nec(i,:) = [norm(C1-C0) norm(C2-C0) norm(C3-C0)]/sqrt(N*T);
end

mcovprob = mean(covprob); 
mCI_length = mean(CI_length); 
