function [rhat,IC]=nkfactors(Y,X,N,RR,h,kernelType,boundaryKern,XTol,maxIter,cf)

[n,p]=size(X);
T = n/N;
if nargin < 10 || isempty(cf)
    cf = 1;
end
if nargin < 9 || isempty(maxIter)
    maxIter = 2000*p;
end
if nargin < 8 || isempty(XTol)
    XTol = 1e-4; 
end
if nargin < 7 || isempty(boundaryKern)
    boundaryKern=1;
end
if nargin < 6 || isempty(kernelType)
    kernelType=1;
end
if nargin < 5 || isempty(h)
    h=2.35/sqrt(12)*T^(-2/9)*N^(-2/9);
end

T = n/N;
nrr = length(RR);
IC = zeros(nrr,9);
for i=1:nrr
    R = RR(i);
    res = kpanelife(Y,X,T,R,h,kernelType,boundaryKern,XTol,maxIter);
    c2 = (min([sqrt(T*h);sqrt(N); h^(-2)]))^2;
     
    cf = 1;
    IC(i,1) = log(res.ssr/n) + cf*R*(N+T*h)/(n*h)*log(n*h/(N+T*h));
    IC(i,2) = log(res.ssr/n) + cf*R*(N+T*h)/(n*h)*log(c2);
    IC(i,3) =  log(res.ssr/n) + cf*R*(N+T )/(n)*log(n/(N+T ));
    cf2 = 1.5; 
    IC(i,4) = log(res.ssr/n) + cf2*R*(N+T*h)/(n*h)*log(n*h/(N+T*h));
    IC(i,5) = log(res.ssr/n) + cf2*R*(N+T*h)/(n*h)*log(c2);
    IC(i,6) =  log(res.ssr/n) + cf2*R*(N+T )/(n)*log(n/(N+T ));
    cf3=2; 
    IC(i,7) = log(res.ssr/n) + cf3*R*(N+T*h)/(n*h)*log(n*h/(N+T*h));
    IC(i,8) = log(res.ssr/n) + cf3*R*(N+T*h)/(n*h)*log(c2);
    IC(i,9) =  log(res.ssr/n) + cf3*R*(N+T )/(n)*log(n/(N+T ));

    %  IC(i,3) = log(res.ssr/n) + cf*R*log(c2)/c2;
end
[~,i1]=min(IC(:,1));
[~,i2]=min(IC(:,2));
[~,i3]=min(IC(:,3));
[~,i4]=min(IC(:,4));
[~,i5]=min(IC(:,5));
[~,i6]=min(IC(:,6));
[~,i7]=min(IC(:,7));
[~,i8]=min(IC(:,8));
[~,i9]=min(IC(:,9));
rhat = [RR(i1) RR(i2)  RR(i3) RR(i4) RR(i5)  RR(i6)  RR(i7) RR(i8)  RR(i9)];
%  rhat = min(RR(i1),RR(i2));


