function beta = o1(Y,X,F)
% assume L is known, estimate beta

[T,~] = size(F);
[n,p] = size(X);
N = n/T;

M = eye(T)-F*((F'*F)\F');% T-by-T
Phi = zeros(p,p);
phi = zeros(p,1);

for i=1:N
    Phi = Phi + X((i-1)*T+1:i*T,:)'*M*X((i-1)*T+1:i*T,:);
    phi = phi + X((i-1)*T+1:i*T,:)'*M*Y((i-1)*T+1:i*T);
end

if cond(Phi)>1e10
    beta = (Phi+1e-6*eye(p))\phi;
else
    beta = Phi\phi;
end


