function [F,V] = o2(Y,X,T,beta,R)
% assume beta is known, estimate factor structure.

[n,p] = size(X);

N = n/T;

Q = zeros(T,T);

for i = 1:N
    et = Y((i-1)*T+1:i*T) - X((i-1)*T+1:i*T,:)*beta; % T-by-1
    Q = Q + et*et'; % T-by-T
end    
Q = Q/n;

[W,lam] = eig(Q);
F = W(:,T:-1:T-R+1)*sqrt(T);
V = lam(T:-1:T-R+1,T:-1:T-R+1);


